require "logger"
require "testcube/version"
require_relative "testcube/adapters/rspec_adapter"
require_relative "testcube/config/env"
require_relative "testcube/tracker"

module Testcube
  class << self
    def logger
      unless @logger
        default_logger = ::Logger.new(STDOUT)
        default_logger.level = Testcube::Config::Env.log_level
        default_logger.formatter = proc do |severity, datetime, progname, msg|
          "[Testcube] #{severity} #{datetime.strftime("%H:%M:%S")}: #{msg}\n"
        end
        @logger = default_logger
      end
      @logger
    end

    def tracker
      Testcube::Tracker.instance
    end
  end
end
