module Testcube
  module Adapters
    class BaseAdapter
      attr_accessor :api_key

      def self.bind(api_key)
        adapter = new
        adapter.api_key = api_key
        if api_key
          adapter.bind
        else
          Testcube.logger.warn('No api key specified. Not recording!')
        end
        adapter
      end

      def bind
        if Testcube::Config::Env.recording_enabled?
          Testcube.logger.info('Test suite time execution recording enabled.')
          bind_time_tracker
          bind_save_report
        end
      end

      def bind_time_tracker
        raise NotImplementedError
      end

      def bind_save_report
        raise NotImplementedError
      end
    end
  end
end
